/*
  But :     
  Auteur : Luca Dias Madeira
  Date :   07.06.2021 / V1.0
*/



$().ready(function () {
    ctrl = new Ctrl();
    ctrl.research.listeCategories = ctrl.research.obtainCategory();
    ctrl.research.listeFirstLetter = ctrl.research.obtainFirstLetter();
    ctrl.research.listeGlasses = ctrl.research.obtainGlass();
    ctrl.research.cocktailfilters = ctrl.research.obtainCocktailFilters();
    ctrl.research.ingredientfilters = ctrl.research.obtainIngredientFilters();
    ctrl.showAvailableFilters();
});
  
  class Ctrl {
      constructor() {
        this.research = new Research();
      }
  
      showAvailableFilters() {
          let changeFilter = this.research.showfilters(document.getElementById("whatToSearch"));
          
          changeFilter(this);

          $("#indicationInput").html('<input type="text" size="20" id="whatForIndication" name="whatForIndication" placeholder="indication...">');
          
          $("#rechercherbtn").html('<a href="#search" onclick="ctrl.recherche();">SEARCH</a>');
      }
      
      adaptIndicationInput() {
        $("#indicationInput").html('<input type="text" size="20" id="whatForIndication" name="whatForIndication" placeholder="indication...">');

        let choosenClassReference = $('#filterSelection select option:selected').attr('class');
        let isFilter = $('#filterSelection select option:selected').attr('value').includes("filter.php");
        
        let commands = this.research.adaptindication(choosenClassReference, isFilter);
        let commande1 = commands[0];
        let commande2 = commands[1];
        commande1(this);
        commande2();
      }

      recherche() {
        let urlResearchTypeValue = $('#filterSelection select option:selected').attr('value');
        let classechoisieParam = $('#filterSelection select option:selected').attr('class');
        let urlParamSelectorIndicators = $('#indicationInput #whatAsFilter option:selected').val();
        let urlParamDefaultValue = $("#whatForIndication").val();
        let whatToSearch = $("#cocktailOrIngredient select option:selected").attr("value");

        let searchInfo = this.research.rechercher(this, urlResearchTypeValue, classechoisieParam, urlParamSelectorIndicators, urlParamDefaultValue, whatToSearch);
        $(".pg2").html("");
        $(".pg3").html("");

        //choix de quel commande faire
        switch (searchInfo.type) {
            case "multipleCocktails":
                this.rechercherPlusieursCocktails(searchInfo.url);
                //this.research.obtainMultipleCocktailResults(url,true,true);
                break;

            case "singleCocktail":
                this.rechercherUnCocktail(searchInfo.url);
                //this.research.obtainSingleCocktailResult(url);
                break;

            default:
                this.rechercherUnIngredient(searchInfo.url);
                //this.research.obtainSingleIngredientResult(url);
                break;
        }
      }







      //PAS FINI
      rechercherPlusieursCocktails(url) {
      }


      rechercherUnCocktail(url) {
          this.research.obtainSingleCocktailResult(url, this.afficherUniqueCocktail, this.afficherPetitsIngredienst);
      }

      rechercherUnIngredient(url) {
          this.research.obtainSingleIngredientResult(url, this.afficherUniqueIngredient, this.afficherPetitsCocktails);
      }

      //PAS FINI
      afficherUniqueIngredient(data, afficherPetitsCocktails) {
          //ici code pour afficher le grand ingredient dans la zone pg2 + description
          let a = data.ingredients;
            if (a === null || a === undefined) {

            } else {
                let contenu = "";
                let oneElement;
                let putAsAlcohol = "";
                let ingred = a[0];

                oneElement = "<div><ul>"; //début entrée
                oneElement += '<li>'+'<img alt='+'"'+ingred.idIngredient+'"'+' class="ingredient" src='+'"'+'https://www.thecocktaildb.com/images/ingredients/'+ ingred.strIngredient +'-Medium.png"'+ '>' + '</li>'; //image
                oneElement += '<li>'; //début liste
                oneElement += '<p>'+ingred.strIngredient+'</p>'; //nom cocktail
                
                
                putAsAlcohol = ingred.strType;
                if (ingred.strAlcohol != null) {
                    putAsAlcohol += ' | '+'Contains Alcohol';
                    if (ingred.strABV != null) {
                        putAsAlcohol += ' ('+ingred.strABV+'%)';
                    }
                }
                if (putAsAlcohol != null) {
                    oneElement += '<p>'+putAsAlcohol+'</p>'; //catégorie, alcool et taux d'alcool
                }
                oneElement += "</li></lu></div>";
                contenu = oneElement;

                if (ingred.strDescription != null) {
                    contenu += '<p class="ingredDesc">'+ingred.strDescription+'</p>';
                }

                $(".pg2").html(contenu);
                $(".pg3").html(ingred.strIngredient);
                $("#rechercherbtn a").html('SEARCH (done)');
            }
      }



      //PAS FINI
      afficherUniqueCocktail(estLeSeul) {
          //ici code pour afficher un grand cocktail dans la zone pg2
      }

      //PAS FINI
      afficherPetitsIngredienst(data) {
          
      }

      afficherPetitsCocktails(data) {
          //ici code pour afficher petit cocktail dans la zone pg3
          //... les affiche tous ... bla bla
          let contenu = '<h2>'+'Cocktails using that ingredient :'+'</h2>';
          let singleElement;
          let a = data.drinks;
          let longueur = a.length;
          for (let i = 0; i < longueur; i++) {
            let drink = a[i];
            singleElement = '<div><ul>';
            singleElement += '<li>'+'<img alt='+'"'+drink.idDrink+'"'+' class="preview" src='+'"' + drink.strDrinkThumb +'/preview"'+ '>' + '</li>'; //image
            let tempvar = "'"+drink.idDrink+"'";
            singleElement += '<li><a href="#'+drink.strDrink+'" onclick="ctrl.showElement(0, '+tempvar+');"><p>'+drink.strDrink+'</p></a></li>'
            singleElement += '</ul></div>';
            contenu += singleElement;
          }
          $('.pg3').html(contenu);
      }

      //PAS FINI
      afficherPlusieursCocktails(data, obtentionEnFiltre, ) {} 

      //PAS FINI
      afficherUnCocktailDepuisFiltre(url, ID) {

      }


      showElement(whatIsIt, elementReference) {
        this.research.showDetails(whatIsIt, elementReference);
      }



  }
  
  
