/*
  But :     
  Auteur : Luca Dias Madeira
  Date :   07.06.2021 / V1.0
*/
class Research {
    constructor() {
        this.listeCategories = "";
        this.listeFirstLetter = "";
        this.listeGlasses = "";
        this.cocktailfilters = "";
        this.ingredientfilters = "";
    }

    obtainCategory() {
        let reponse;
        var a;
        let settings = {
            "url": "https://www.thecocktaildb.com/api/json/v1/1/list.php?c=list",
            method: "GET",
            async: false
        }
        let total = "";
        $.ajax(settings).done(function (reponse) {
            a = reponse.drinks;
            let longueur = a.length;
    
            for (let i = 0; i < longueur; i++) {
                const drink = a[i];
    
            }
            let contenu = '<option select value='+"'"+(a[0].strCategory)+"'"+'>'+(a[0].strCategory)+'</option>';
            
        for (let i = 1; i < reponse.drinks.length; i++) {
            contenu = contenu + '<option value='+"'"+(a[i].strCategory)+"'"+'">'+(a[i].strCategory)+'</option>';
        }
        total = contenu;
        });
        return total;
    }
    
    obtainFirstLetter() {
        let content = '<option select value='+"'"+"a"+"'"+'>'+"a"+'</option>';
        let alphabet = "bcdefghijklmnopqrstuvwxyz";
        for (let i = 0; i < alphabet.length; i++) {
            content =  content + '<option value='+"'"+(alphabet.charAt(i))+"'"+'>'+(alphabet.charAt(i))+'</option>';
        }
        return content;
    }
    
    obtainGlass() {
        let reponse2 = "";
        let a2 = "";
        let settings2 = {
            url: "https://www.thecocktaildb.com/api/json/v1/1/list.php?g=list",
            method: "GET",
            async: false
        }
        let total = ""
        $.ajax(settings2).done(function (reponse2) {
            a2 = reponse2.drinks;
            let longueur = a2.length;
            for (let i = 0; i < longueur; i++) {
                const drink = a2[i];
            }
            let contenu3 = '<option select value='+"'"+(a2[0].strGlass)+"'"+'>'+(a2[0].strGlass)+'</option>';
                
            for (let i = 1; i < reponse2.drinks.length; i++) {
                contenu3 = contenu3 + '<option value='+"'"+(a2[i].strGlass)+"'"+'">'+(a2[i].strGlass)+'</option>';
            }
            total = contenu3;
        });
        return total;
    }
    
    obtainCocktailFilters() {
        let total = "";
        $.get({
            url: "txt/cocktailfilters.txt",
            async: false
        }, function(data) {
        let content = data;
        total = content;
        }, 'text');
        return total;
    }
    
    obtainIngredientFilters() {
        let total = "";
        $.get({
            url: "txt/ingredientfilters.txt",
            async: false
        }, function(data) {
        let content = data;
        total = content;
        }, 'text');
        return total;
    }
    
    showfilters(whatToSearch) {
        //création de la variable ayant le total du retour
        let whatAsFilter;
        //mettre valeur par défaut pour le filtre et les autres input
        switch (whatToSearch.value) {
            case "cocktail":
                whatAsFilter = function(ctrl) {
                    $('#whatAsFilter').prop('disabled', false);
                    //changement des options disponibles
                    $("#whatAsFilter").html(ctrl.research.cocktailfilters);
                }
                break;
            case "ingredient":
                whatAsFilter = function() {
                    $('#whatAsFilter').prop('disabled', false);
                    //changement des options disponibles
                    $("#whatAsFilter").html(ctrl.research.ingredientfilters);
                }
                break;
            default: //pour le "find..."
                whatAsFilter = function() {
                    $('#whatAsFilter').attr('disabled','disabled');
                }
                break;
        }
        return whatAsFilter;
    }

    //modifie indication selon le filtre choisi, selon les classes du filtre
    adaptindication(choosenClassReference, isFilter) {
    
        //vérification de quelle classe est présente :
        let classechoisie = this.obtainOptionClass(choosenClassReference);
        let varToReturn;
        let changeIndication;
        let commandsForFilters;
    
        switch (classechoisie) {
            case "noIndication":
                changeIndication = function(ctrl) {
                    //mettre en disabled
                    $("#whatForIndication").prop('disabled', true);
                }
                break;
            case "limitedIndications":
                changeIndication = function(ctrl) {
                    $("#indicationInput").html('<select name="whatAsFilterSELECT" id="whatAsFilter">'+ ctrl.research.listeCategories +'</select>');
                }
                break;
            case "oneLetterOnly":
                changeIndication = function(ctrl) {
                    $("#indicationInput").html('<select name="whatAsFilterSELECT" id="whatAsFilter">'+ ctrl.research.listeFirstLetter +'</select>');
                }
                break;
            case "searchByGlass":
                changeIndication = function(ctrl) {
                    $("#indicationInput").html('<select name="whatAsFilterSELECT" id="whatAsFilter">'+ ctrl.research.listeGlasses +'</select>');
                }
                break;
            case "numberOnlyIndication":
                changeIndication = function(ctrl) {
                    let oninput = 'oninput="'+"validity.valid||(value='');"+'"';
                    let indication = "exemple: ";
                    switch (document.getElementById("whatToSearch")) {
                        case "ingredient":
                            indication = indication + "552";
                            break;
                        default:
                            indication = indication + "11007";
                            break;
                    }
                    $("#indicationInput").html('<input type="number" min="0" step="1" '+oninput+' size="20" id="whatForIndication" name="whatForIndication" placeholder="'+indication+'">');
                }
                break;
           default:
               changeIndication = function() {
                   console.log("rien à faire !");
               }
                //tout bon déjà
                break;
        }

        if (isFilter) {
            commandsForFilters = function() {
                $("#rechercherbtn").html('<a href="#search" class="redsearch" onclick="ctrl.recherche();">SEARCH (wait time)</a>');
                $("#indicationInput input").attr("placeholder","NO SEARCH IF EMPTY");
            }
        } else {
            commandsForFilters = function() {
                $("#rechercherbtn").html('<a href="#search" onclick="ctrl.recherche();">SEARCH</a>');
            }
        }

        varToReturn = [changeIndication, commandsForFilters];
        return varToReturn;
    }

    //obtenir la (dernière) classe d'un objet si elle est dans la liste
    obtainOptionClass(classes) {
        const verification = ["noIndication","limitedIndications","oneLetterOnly","searchByGlass","numberOnlyIndication"];
                let classechoisie = "";

                if (classes !== undefined) {
                    const res = classes.split(" ");
                    res.forEach(element => {
                        verification.forEach(element => {
                            if (classes.indexOf(element) > -1) {
                                classechoisie = element;
                            }
                        });
                    });
                }
        return classechoisie;
    }

    rechercher(ctrl, urlResearchType, classechoisieParam, urlParamSelectorIndicators, urlParamDefaultValue, whatToSearch) {
        //1: préparer la valeur de retour
        let varToReturn;
        let searchtype;
        //base de l'url
        let urlBase = "https://www.thecocktaildb.com/api/json/v1/1/";


        //paramètres de la recherche URL, s'il y en a
        let classechoisie = this.obtainOptionClass(classechoisieParam);
        let urlParam;
        switch (classechoisie) {
            case "noIndication": //  a) si disabled:
            urlParam = "";
                break;
            case "limitedIndications":
            case "oneLetterOnly":
            case "searchByGlass": //  b) si select:
                urlParam = urlParamSelectorIndicators;
                break;
            default: //  c) si champ de texte:
                urlParam = urlParamDefaultValue;
                break;
        }
        

        //url total
        let url = urlBase + urlResearchType + urlParam;

        //2: choisir selon la requête (classe du filtre + valeur du premier select)
        let mustSearchForCocktail = true;
        let multipleResults = true;

        //voir si on veut à la place chercher un ingrédient
        if (whatToSearch === "ingredient") {
            mustSearchForCocktail = false;
        }

        //voir si on veut à la place avoir un seul résultat
        let ras = classechoisieParam
        if (ras !== undefined) {
            let res = ras.split(" ");
            if (res.length > 1) {
                res.forEach(element => {
                    if (element === "oneElementResult") {
                        multipleResults = false;
                    }
                });
            }
        }

        //3: charger la page / mettre les infos sur la page
        switch (mustSearchForCocktail) {
            case true:
                switch (multipleResults) {
                    case true:
                        //this.research.obtainMultipleCocktailResults(url,true,true);
                        searchtype = "multipleCocktails";
                        break;
                
                    default:
                        //this.research.obtainSingleCocktailResult(url);
                        searchtype = "singleCocktail";
                        break;
                }
                break;

            default:
                //this.research.obtainSingleIngredientResult(url);
                searchtype = "singleIngredient";
                break;
        }
        varToReturn = {
            url: url,
            type: searchtype
        };
        return varToReturn;
    }






    //PAS FINI
    obtainMultipleCocktailResults(theUrl, isAsync = true, returnMultiples = false) {
        let reponse = "";
        let a = "";
        let settings = {
            url: theUrl,
            method: "GET",
            async: isAsync
        }
        $.ajax(settings).done(function (reponse) {
            //#region 
            const obtainCocktailInformations = function(ID) {
                let theCocktailsDetails = "";
                let reponse = "";
                let theUrl = "https://www.thecocktaildb.com/api/json/v1/1/lookup.php?i="+ID;
                let a = "";
                let settings = {
                    url: theUrl,
                    method: "GET",
                    async: false
                }
                $.ajax(settings).done(function (reponse) {
                    a = reponse.drinks;
                    const drink = a[0];
                    console.log(drink);
                    theCocktailsDetails = drink;
                });
                return theCocktailsDetails;
            };
            //#endregion

            a = reponse.drinks;

            if (a === null || a === undefined) {

            } else {
                let longueur = a.length;
                let contenu = "";
                let oneElement;
                let tags = "";
                let tagList;
                let Ingredients = "";
                for (let i = 0; i < longueur; i++) {
                    let drink = a[i];
                    if (drink.strTags !== undefined) {
                    } else {
                        drink = obtainCocktailInformations(drink.idDrink);
                    }

                    oneElement = '<div><ul>'; //début entrée


                    //POSSIBLE AMELIORATION
                    oneElement += '<li>'+'<img alt='+'"'+drink.idDrink+'"'+' class="preview" src='+'"' + drink.strDrinkThumb +'/preview"'+ '>' + '</li>'; //image
                    //


                    
                    oneElement += '<li>'; //début liste
                    oneElement += '<a href="#'+drink.strDrink+'" onclick="ctrl.showElement(0, '+drink.idDrink+');"><p>'+drink.strDrink+'</p></a>'; //nom cocktail



                    //POSSIBLE AMELIORATION
                    let tempvar = "'"+drink.strCategory+"'";
                    oneElement += '<p><a href="#'+drink.strCategory+'" onclick="ctrl.showElement(2, '+tempvar+');"'+'>'+drink.strCategory+'</a> | ';
                    let tempvar2 = "'"+drink.strGlass+"'";
                    oneElement += '<a href="#'+drink.strGlass+'" onclick="ctrl.showElement(3, '+tempvar2+');"'+'>'+drink.strGlass+'</a> | <br/>'+drink.strAlcoholic+'</p>'; //catégorie, alcool et verre
                    //


                    //tags
                    tags = "No Tags";
                    if (drink.strTags !== null) {
                        tags = "Tags : ";
                        if (drink.strTags.includes(',')) {
                            tagList = drink.strTags.split(',');
                            tagList.forEach(tag => {
                                tags += tag + ', ';
                            });
                        } else {
                            tags += drink.strTags;
                        }
                    }

                    oneElement += '<p>'+tags+'</p>'; //nom cocktail
                    oneElement += '<p class="instructions">'+drink.strInstructions+'</p>'; //instructions


                    //quantités + ingrédients
                    Ingredients = "If you see this message, someone forgot to say what ingredients are used";
                    if (drink.strIngredient1 !== null) {
                        Ingredients = "";
                        let strName = "";
                        let strQName = "";
                        let strNameAfter = "";
                        let y = 0;
                        let finalresult = "";
                        let ingredientNames = ""; //pour le single cocktail result
                        for (let i = 1; i <= 15; i++) {
                            y = i+1;
                            strName = "strIngredient"+i;
                            strNameAfter = "strIngredient"+y;
                            strQName = "strMeasure"+i;
                            if (drink[strName] !== null) {
                                if (drink[strQName] != null) {
                                    finalresult = drink[strQName]+' '+drink[strName];
                                } else {
                                    finalresult = drink[strName];
                                }
                                
                                //A REVERIFIER
                                let tempvar = "'"+drink[strName]+"'";
                                Ingredients += '<a href="#'+drink[strName]+'" '+'onclick="ctrl.showElement(1, '+tempvar+');"'+' >'+finalresult+'</a>';
                                //
                                ingredientNames += drink[strName]+','+drink[strQName];
                                
                                if (drink[strNameAfter] !== null) {
                                    Ingredients += ' | ';
                                    ingredientNames += ' | ';
                                }
                                
                            }  
                        }
                        $('.pg3').html(ingredientNames);
                    }
                    oneElement += '<p>'+Ingredients+'</p>';
                    oneElement += '</li>' //fin liste
                    oneElement += "</ul></div>"; //fin entrée
    

                    contenu += oneElement;
                }
                $(".pg2").html(contenu);

                //supprimer les noms mis dans la seconde section vu que inutile sauf pour le oneElement result
                $("#rechercherbtn a").html('SEARCH (done)');
                if (longueur > 1) {
                    $('.pg3').html("");
                }
            }
            if (returnMultiples) {
                $('p').remove('.instructions');
                $('.pg3').html("");
            }
        });
        return null;
    }

    obtainSingleCocktailResult(url, afficherUniqueIngredient, afficherPetitsCocktails) {
        let settings = {
            url: theUrl,
            method: "GET",
            success: function (data, afficherPetitsCocktails) {
                afficherUniqueIngredient(data, afficherPetitsCocktails);
            }
        }
        $.ajax(settings);
    }



    obtainSingleIngredientResult(theUrl, afficherUniqueIngredient, afficherPetitsCocktails) {
        let settings = {
            url: theUrl,
            method: "GET",
            success: function(data, afficherPetitsCocktails) {
                afficherUniqueIngredient(data, afficherPetitsCocktails);
            }
        }
        $.ajax(settings);
    }
    



    //PAS FINI
    showDetails(whatIsIt, elementReference) {
        if (elementReference !== undefined) {
            $(".pg2").html("");
            $(".pg3").html("");
            let url = 'https://www.thecocktaildb.com/api/json/v1/1/';

            switch (whatIsIt) {
                case 0://"drink"
                    url += 'lookup.php?i='+elementReference;
                    this.obtainSingleCocktailResult(url);
                    break;
            
                case 1://"ingredient"
                    url += 'search.php?i='+elementReference;
                    this.obtainSingleIngredientResult(url);
                    break;

                case 2://"category"
                    url += 'filter.php?c='+elementReference;
                    this.obtainMultipleCocktailResults(url, true, true);
                    break;
                    
                case 3://"glass"
                    url += 'filter.php?g='+elementReference;
                    this.obtainMultipleCocktailResults(url, true, true);
                    break;

                default:
                    break;
            }
        }
    }





    

}

      